<template>
  <div class="sellAfterApply pagePadding">
    <div v-if="powers.some((i) => i == '001')">
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @selection="handleSelection"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="3" style="width: 120px">
                <el-switch 
                  v-model="parmValue.use_type"
                  :active-value="usetypeOtions[1].value"
                  :inactive-value="usetypeOtions[0].value"
                  :active-text="usetypeOtions[1].label"
                  :inactive-text="usetypeOtions[0].label"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                />
              </el-col>
              <!-- 时间选择 -->
              <el-col :span="4" style="width: 303px; padding: 0 0 0 10px">
                <period-date-picker
                  :start="parmValue.start"
                  :end="parmValue.end"
                  :width="'135px'"
                  :size="searchSize"
                  @timeReturned="handleTime"
                />
              </el-col>
              <!-- 客户公司 -->
              <el-col :span="4" style="width: 240px; padding: 0px 0 0 10px">
                <search-customer
                  :value="parmValue.customer_code"
                  :names="parmValue.customerName"
                  :is-detail="true"
                  :size="searchSize"
                  style="width: 100%"
                  :placeholder="'客户公司名称'"
                  @searchChange="customerChange"
                />
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
            </el-row>

            <el-row style="padding: 10px 0 0 0">
              <el-col :span="4" style="width: 200px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.status"
                  clearable
                  style="width: 100%"
                  placeholder="状态"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in serviceOptions"
                    :key="item.id"
                    :label="item.label"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 151px; padding: 0 0 0 10px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.order_source"
                  filterable
                  clearable
                  placeholder="订单来源"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in xs_order_source_options"
                    :key="'orderstatus' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 151px; padding: 0 0 0 10px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.order_type"
                  filterable
                  clearable
                  placeholder="商品类型"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in xs_order_type_options"
                    :key="'orderstatus' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>

              <el-col :span="3" style="width: 240px; padding: 0 0 0 10px">
                <search-supplier
                  :size="'mini'"
                  style="width: 100%"
                  :value="parmValue.supplierNo"
                  :disabled="false"
                  :placeholder="'供应商名称'"
                  :names="parmValue.supplierName"
                  :isDetail="true"
                  :noDisabled="true"
                  @searchChange="supplierChange"
                />
              </el-col>

              <el-col :span="2" style="width: 65px; float: right">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
            </el-row>

            <el-row style="padding-top: 10px">
              <el-col :span="4" style="width: 501px">
                <el-input
                  clearable
                  :size="searchSize"
                  maxlength="40"
                  placeholder="关键字"
                  v-model="s_input"
                  class="input-with-select"
                >
                  <el-select
                    style="width: 150px"
                    v-model="select"
                    slot="prepend"
                    placeholder="关键字类型"
                  >
                    <el-option label="售后申请编号" value="serviceNum"></el-option>
                    <el-option label="发货单编号" value="sellOutNum"></el-option>
                    <el-option label="销售订单编号" value="orderCode"></el-option>
                    <el-option label="商品编号" value="goodsNum"></el-option>
                    <el-option label="商品名称" value="goodsName"></el-option>
                    <el-option label="申请人部门" value="company_name"></el-option>
                    <el-option label="申请人" value="applyer"></el-option>
                  </el-select>
                  <el-button
                    slot="append"
                    icon="el-icon-search"
                    @click="handleValue"
                  ></el-button>
                </el-input>
              </el-col>
              <el-col :span="4" style="width: 66px; float: right" v-if="!isSupertube && powers.includes('087')">
                <el-button type="primary" size="mini" @click="handleExport">
                  导出
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #order_type="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (
                xs_order_type_options.find((item) => item.id == scope.row.order_type) ||
                {}
              ).label || '--'
            "
          ></el-tag>
        </template>

        <template #has_account="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="
              (
                has_account_list.find(
                  (item) => item.code == scope.row.has_account + ''
                ) || {}
              ).type || '--'
            "
            v-text="
              (
                has_account_list.find(
                  (item) => item.code == scope.row.has_account + ''
                ) || {}
              ).name || '--'
            "
          ></el-tag>
        </template>

        <template #use_type="{ scope }">
          <el-tag size="mini">
            {{
              (usetypeOtions.find(({ value }) => value === scope.row.use_type) || {})
                .label || "---"
            }}
          </el-tag>
        </template>

        <template #order_source="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (
                xs_order_source_options.find(
                  (item) => item.id == scope.row.order_source
                ) || {}
              ).label || '--'
            "
          ></el-tag>
        </template>

        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {}).label ||
              '--'
            "
          ></el-tag>
        </template>
        <!-- 费用承担方 -->
        <template #post_own="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (post_ownOptions.find((item) => item.id == scope.row.post_own) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <!-- 期望意愿 -->
        <template #except_code="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (except_codeOptions.find((item) => item.id == scope.row.except_code) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="getRouter('sellAfterApplyDetail', scope.row.returnCode)"
            ></i>
          </el-tooltip>

          <el-tooltip
            class="fr"
            effect="dark"
            content="取消申请"
            v-if=" 
              !statusList.includes(Number(scope.row.status))  &&
              powers.some((i) => i == '027') && !isSupertube
            "
            placement="top"
            >
               <i class="el-icon-circle-close tb-icon" @click="() => close_return(scope.row.returnCode)"></i>
            </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>

<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/sellOut/sellAfterApply";
import { columns } from "./columns";
import { mapGetters } from "vuex";
import urlConfig from "@/apis/url-config";
import {
  xs_order_source_options,
  xs_order_type_options,
  has_account_list,
  usetypeOtions,
} from "@/assets/js/statusList";
import companyHelper from "@/mixins/companyHelper";

export default {
  name: "sellAfterApply",
  mixins: [mixinPage, resToken, companyHelper],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size", "isSupertube"]),
    powers() {
      const tran = this.$store.getters.btnList.find((item) => item.menu_route == "sellAfterApply") || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      supplierNo: "",
      statusList:[5,6,8,11,12],
      xs_order_source_options,
      xs_order_type_options,
      has_account_list,
      fileUrl: urlConfig.baseURL,
      usetypeOtions,
      select: "serviceNum",
      select_list: [],
      s_input: "",
      customerCode: [], //客户公司code
      except_codeOptions: [
        { id: "1", label: "退货" },
        { id: "2", label: "换货" },
        { id: "3", label: "改变售价" }
      ],
      post_ownOptions: [
        { id: "1", label: "客户承担" },
        { id: "2", label: "公司承担" },
        { id: "3", label: "供应商承担" }
      ],
      sitem: null,
      // 收到货状态
      statusOptions: [
        { id: "1", label: "待业务审核" }, //
        { id: "9", label: "供应商审核" },
        { id: "2", label: "供应商驳回,待采购审核" }, //  id: "2", label: "供应商驳回,待供应商负责人审核" },
        { id: "10", label: "业务公司修改，待供应商确认" },
        { id: "11", label: "待设置工单" }, //已收到货才有
        { id: "4", label: "待客户退货" }, //已收到货才有
        { id: "12", label: "待库管收货" }, //已收到货才有
        { id: "5", label: "售后已完成" },
        { id: "6", label: "业务已驳回" },
        { id: "8", label: "申请已取消" },
      ],
      loading: false,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        customerCode:"",
        customerName:"",
        supplierNo:"",
        supplierName:"",
        use_type: "1",
        has_account: "",
        order_source: "",
        good_code: "", //商品编码
        orderCode: "",
        outCode: "",
        except_code: "", //期望意愿
        serviceValue: "", //处理状态
        start: "",
        end: "",
        order_type: "",
        customer_code: "", //客户公司code
        returnCode: "", //售后单号
        apply_name: "", //申请人名称
        good_name: "", //商品名称
        except_code: "", //期望意愿
        company_name: "", //申请人部门
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
      // 处理状态
      serviceOptions: [
        { id: "1", label: "待业务审核" },
        { id: "2", label: "供应商驳回,待采购审核" }, //  id: "2", label: "供应商驳回,待供应商负责人审核" },
        //{ id: "2", label: "待设置仓库" },//节点废除
        { id: "4", label: "待客户退货" }, //已收到货才有
        { id: "5", label: "售后已完成" },
        { id: "6", label: "业务已驳回" },
        //{ id: "7", label: "采购已驳回" },//节点废除
        { id: "8", label: "申请已取消" },
        { id: "9", label: "供应商审核" },
        { id: "10", label: "业务公司修改，待供应商确认" },
        { id: "11", label: "待设置工单" }, //已收到货才有
        { id: "12", label: "待库管收货" }, //已收到货才有
      ],
      // 期望意愿
      expectOptions: [
        {
          value: "1",
          label: "退货",
        },
        {
          value: "2",
          label: "换货",
        },
        {
          value: "3",
          label: "改变售价",
        },
      ],
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      const { page, size } = this.parmValue;

      if (this.parmValue.customer_code.length > 0) {
        this.customerCode = [this.parmValue.customer_code];
      }

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      this.input = this.parmValue.input;
    } else {
      this.select = "orderCode";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    async supplierChange(e) {
      const { code, label } = e;
      this.parmValue.supplierNo = code ? [code] : [];
      this.parmValue.supplierName = label
      this.searchList();
    },
    handleExport() {
      if (this.select_list.length === 0) {
        this.$message.warning("请选择一条售后申请单");
        return;
      }
      const returnCode = this.select_list.map(({ returnCode }) => returnCode);

      if (!this.loading) {
        this.loading = true;
        let httpType = `aplication/zip`;
        axios({
          method: "post",
          url: this.fileUrl + "/admin/reorderexam",
          responseType: "blob",
          data: { returnCode },
          headers: {
            Accept: httpType,
          },
        })
          .then((res) => {
            if (res && res.status == 200 && res.data) {
              let url = window.URL.createObjectURL(
                new Blob([res.data], { type: httpType })
              );
              let link = document.createElement("a");
              link.style.display = "none";
              link.href = url;
              let excelName = "售后申请单.zip";
              link.setAttribute("download", excelName);
              document.body.appendChild(link);
              link.click();
              link.remove();
              window.URL.revokeObjectURL(url); //释放掉blob对象
              this.$message.success(`导出成功！`);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            } else {
              this.$message.error(res.data.message);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            }
          })
          .catch((error) => {
            console.log(error);
            this.loading = false;
          });
      }
    },
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          type: "view",
        };

        //有多选框的条件
        this.parmValue.select = this.select;
        this.parmValue.input = this.input;
        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    async close_return(returnCode) {
      await this.$confirm("确定要取消申请？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            returnCode
          };
          const res = await asyncRequest.aftercancel(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "取消成功",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    restSearch() {
      this.customerCode = [];
      this.select = "serviceNum";
      this.s_input = "";
      this.parmValue = {
        use_type:'1',
        order_type: "",
        customer_code: "", //客户公司code
        start: "",
        end: "",
        returnCode: "", //售后单号
        apply_name: "", //申请人名称
        good_code: "", //商品编码
        orderCode: "",
        outCode: "",
        good_name: "", //商品名称
        except_code: "", //期望意愿
        company_name: "", //申请人部门
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    handleSelection(order) {
      const { list } = order;
      this.select_list = list;
    },
    // 列表搜索
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;
      this.parmValue.apply_name = this.select === "applyer" ? this.s_input : ""; // 产品属性编号
      this.parmValue.good_name = this.select === "goodsName" ? this.s_input : ""; // 采购单编码
      this.parmValue.good_code = this.select === "goodsNum" ? this.s_input : ""; // 入库单号
      this.parmValue.returnCode = this.select === "serviceNum" ? this.s_input : ""; // 产品名称
      this.parmValue.orderCode = this.select === "orderCode" ? this.s_input : ""; // 备库编码
      this.parmValue.outCode = this.select === "sellOutNum" ? this.s_input : ""; // 申请人
      this.parmValue.company_name = this.select === "company_name" ? this.s_input : ""; // 申请人部门

      let model = JSON.parse(JSON.stringify(this.parmValue));
      delete model['supplierName']
      delete model['customerName']
      const res = await asyncRequest.list({
        ...model,
        customer_code:Array.isArray(this.parmValue.customer_code) ? this.parmValue.customer_code[0] : this.parmValue.customer_code,
        supplierNo: Array.isArray(this.parmValue.supplierNo) ? this.parmValue.supplierNo[0] : this.parmValue.supplierNo,
        needRela: true,
      });

      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status + "" === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 时间选择事件
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }
      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    // 客户选择
    async customerChange(e) {
      this.parmValue.customer_code = [e.code];
      this.parmValue.customerName = e.label;
      this.parmValue.page = 1;
      await this.searchList();
    },
    async handleValue() {
      await this.searchList();
    },
  },
};
</script>
<style lang="scss" scoped></style>
